Bug 14257 - Add show_extended_attributes to ILS-DI call GetPatronInfo
Summary: Add show_extended_attributes to ILS-DI call GetPatronInfo
Status: CLOSED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Web services (show other bugs)
Version: master
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Bugs List
QA Contact: Katrin Fischer
URL:
Keywords:
Depends on:
Blocks: 21199
  Show dependency treegraph
 
Reported: 2015-05-22 19:29 UTC by Viktor Sarge
Modified: 2018-08-09 22:34 UTC (History)
4 users (show)

See Also:
Change sponsored?: ---
Patch complexity: Trivial patch
Who signed the patch off:
Text to go in the release notes:
Version(s) released in:


Attachments
Bug 14257 - Add show_attributes to GetPatronInfo (2.00 KB, patch)
2015-11-09 15:11 UTC, Martin Persson
Details | Diff | Splinter Review
Bug 14257 - Add show_attributes to GetPatronInfo (3.06 KB, patch)
2015-11-10 15:15 UTC, Martin Persson
Details | Diff | Splinter Review
Bug 14257 - Add show_attributes to GetPatronInfo (4.21 KB, patch)
2015-11-14 18:12 UTC, Martin Persson
Details | Diff | Splinter Review
Bug 14257 - Add show_attributes to GetPatronInfo (3.06 KB, patch)
2015-11-14 18:15 UTC, Martin Persson
Details | Diff | Splinter Review
Bug 14257 - Add show_attributes to GetPatronInfo (3.12 KB, patch)
2016-03-25 09:17 UTC, Mirko Tietgen
Details | Diff | Splinter Review
Bug 14257 - Add show_attributes to GetPatronInfo (4.27 KB, patch)
2016-03-25 09:20 UTC, Mirko Tietgen
Details | Diff | Splinter Review
Bug 14257 - Add show_attributes to GetPatronInfo (3.12 KB, patch)
2016-03-25 09:20 UTC, Mirko Tietgen
Details | Diff | Splinter Review
Bug 14257: Follow-up - Add documentation, fix typo, fix test (2.73 KB, patch)
2016-03-30 06:16 UTC, Katrin Fischer
Details | Diff | Splinter Review
[PASSED QA] Bug 14257 - Add show_attributes to GetPatronInfo (4.34 KB, patch)
2016-03-30 21:52 UTC, Katrin Fischer
Details | Diff | Splinter Review
[PASSED QA] Bug 14257 - Add show_attributes to GetPatronInfo (3.19 KB, patch)
2016-03-30 21:52 UTC, Katrin Fischer
Details | Diff | Splinter Review
Bug 14257: Follow-up - Add documentation, fix typo, fix test (2.73 KB, patch)
2016-03-30 21:52 UTC, Katrin Fischer
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Viktor Sarge 2015-05-22 19:29:07 UTC
I can not seem to get extended patron attributes from GetPatronInfo. I propose we add this as an optional parameter (default 0) to ILS-DI GetPatronInfo. 

( The use case that triggered this idea was letting people into the library after hours by logging in. We'd then use AuthenticatePatron to log them in and then look at a yes/no flag for those who are trusted to use the after hours service. This flag is coming from a extended patron attribute, but without a clean way to check it this will not work. )
Comment 1 Martin Persson 2015-11-09 15:11:59 UTC Comment hidden (obsolete)
Comment 2 Martin Persson 2015-11-10 15:15:31 UTC Comment hidden (obsolete)
Comment 3 Martin Persson 2015-11-14 18:12:27 UTC Comment hidden (obsolete)
Comment 4 Martin Persson 2015-11-14 18:15:22 UTC Comment hidden (obsolete)
Comment 5 Mirko Tietgen 2016-03-25 09:17:17 UTC Comment hidden (obsolete)
Comment 6 Mirko Tietgen 2016-03-25 09:20:10 UTC Comment hidden (obsolete)
Comment 7 Mirko Tietgen 2016-03-25 09:20:19 UTC Comment hidden (obsolete)
Comment 8 Katrin Fischer 2016-03-29 22:43:19 UTC
Just 2 notes for now:
- we need to update the documentation
- there is a typo hiding somewhere:    
  FAIL	  spelling
  comparision  ==> comparison
Comment 9 Katrin Fischer 2016-03-30 06:16:08 UTC Comment hidden (obsolete)
Comment 10 Katrin Fischer 2016-03-30 06:16:58 UTC
Still working on this!
Comment 11 Katrin Fischer 2016-03-30 21:52:05 UTC
Created attachment 49696 [details] [review]
[PASSED QA] Bug 14257 - Add show_attributes to GetPatronInfo

Added unit tests to for GetBorrowerAttributes and GetPatronInfo.

Sponsored-By: Halland County Library

Signed-off-by: Mirko Tietgen <mirko@abunchofthings.net>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 12 Katrin Fischer 2016-03-30 21:52:08 UTC
Created attachment 49697 [details] [review]
[PASSED QA] Bug 14257 - Add show_attributes to GetPatronInfo

This patch adds the ability to query the extended patron
attributes via the ILSDI web service's GetPatronInfo service.

Example: ilsdi.pl?service=GetPatronInfo&patron_id=3&show_attributes=1

A new element <attributes> will be added if there
are any attributes available from the database.

We need to discuss the security implications of showing the
attributes. At present it will allow querying of non-public
(OPAC-visible) information. We might want to change this.

Sponsored-By: Halland County Library

Test plan:

* Configure Koha to make use of extended attributes:
  Under 'Administration' -> 'Global system preferences' ->
  'Patrons' tab -> Set 'ExtendedPatronAttributes' to 'Enable',
  press save and switch to 'Web services' tab.

* Enable the ILS-DI service:
  Under 'Administration' -> 'Global system preferences' ->
  'Web services' tab -> 'ILS-DI' section:
  Set 'ILS-DI' to 'Enable' and save.

* Create an attribute to query:
  Under 'Administration' -> 'Patrons and circulation' ->
  'Patron attribute types' press 'New patron attribute type':
  Enter a type code, like 'DOORCODE', description and assign
  a category that your test patron is a member of, then save.

* Set value for test user:
  Locate the test patron, the new attribute should be listed
  under 'Additional attributes and identifiers'.
  Click 'Edit' and assign a value, like '1337' and save.

* Query the ILS-DI service:
  http://127.0.1.1/cgi-bin/koha/ilsdi.pl?service=GetPatronInfo&patron_id=1&show_attributes=1
  The output XML should have an element named 'attributes'
  containing the data you entered.

Signed-off-by: Mirko Tietgen <mirko@abunchofthings.net>

Signed-off-by: Katrin Fischer <katrin.fischer.83@web.de>
Comment 13 Katrin Fischer 2016-03-30 21:52:11 UTC
Created attachment 49698 [details] [review]
Bug 14257: Follow-up - Add documentation, fix typo, fix test

- t/db_dependent/ILSDI_Services.t was failing for me as I had
  issues in my database, fixed with another delete line
- QA tools found a typo - comparision
- Added documentation of the new parameter to the ilsdi.pl page
Comment 14 Brendan Gallagher 2016-03-31 20:38:13 UTC
Pushed to Master - Should be in the May 2016 release.  Thanks!
Comment 15 Jonathan Druart 2018-07-12 20:47:30 UTC
I am currently working on moving this code the Koha namespace and I do not understand what is needed exactly here.

So far we have:
<attributes>
  <code>xxx</code>
  <value>1</value>
  <class/>
  <value_description>Damaged</value_description>
  <description>pouet peout</description>
  <display_checkout>0</display_checkout>
</attributes>

Maybe we just need a couple variable=value, right?